Package com.io7m.jtensors.storage.bytebuffered

# Class VectorByteBufferedIntegral3s8

java.lang.Object
com.io7m.jtensors.storage.bytebuffered.VectorByteBufferedIntegral3s8

All Implemented Interfaces:
  `VectorReadable2LType`, `VectorReadable3LType`, `VectorStorageIntegral2Type`, `VectorStorageIntegral3Type`, `VectorStorageType`, `TensorByteBufferedType`, `VectorByteBufferedIntegral2Type`, `VectorByteBufferedIntegral3Type`, `VectorByteBufferedType`

    public final class VectorByteBufferedIntegral3s8
    extends java.lang.Object
    implements VectorByteBufferedIntegral3Type

A storage vector.

Storage component type: `byte`

Storage component count: `3`

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `java.nio.ByteBuffer` | `byteBuffer()` |
  `long` | `byteOffset()` |
  `protected int` | `byteOffsetForIndex​(int component_index)` |
  `protected int` | `componentBytes()` |
  `protected int` | `componentCount()` |
  `static VectorByteBufferedIntegral3s8` | `createWithBase​(java.nio.ByteBuffer b, com.io7m.mutable.numbers.core.MutableLongType base, int offset)` | Return a new vector that is backed by the given byte buffer `b`
  `int` | `offset()` |
  `void` | `setX​(long x)` | Set the `x` component.
  `void` | `setY​(long y)` | Set the `Y` component.
  `void` | `setZ​(long z)` | Set the `z` component.
  `int` | `sizeBytes()` |
  `long` | `x()` |
  `long` | `y()` |
  `long` | `z()` |

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.io7m.jtensors.storage.bytebuffered.TensorByteBufferedType

  `byteBuffer, byteOffset, offset, sizeBytes`

  ### Methods inherited from interface com.io7m.jtensors.storage.api.unparameterized.vectors.VectorStorageIntegral2Type

  `setVector2I, setVector2L, setXY`

  ### Methods inherited from interface com.io7m.jtensors.storage.api.unparameterized.vectors.VectorStorageIntegral3Type

  `setVector3I, setVector3L, setXYZ`

- ## Method Details

  - ### createWithBase

    public static VectorByteBufferedIntegral3s8 createWithBase​(java.nio.ByteBuffer b, com.io7m.mutable.numbers.core.MutableLongType base, int offset)

    Return a new vector that is backed by the given byte buffer `b`

    The data for the instance will be taken from the data at the current value of `base.get() + offset`, each time a field is requested or set.

    No initialization of the data is performed.

    Parameters:
      `b` - The byte buffer
      `base` - The base address
      `offset` - A constant offset
    Returns:
      A new buffered vector

  - ### componentCount

    protected int componentCount()

  - ### x

    public long x()
    Specified by:
      `x` in interface `VectorReadable2LType`
    Returns:
      The `x` component

  - ### y

    public long y()
    Specified by:
      `y` in interface `VectorReadable2LType`
    Returns:
      The `y` component

  - ### z

    public long z()
    Specified by:
      `z` in interface `VectorReadable3LType`
    Returns:
      The `z` component

  - ### setX

    public void setX​(long x)
    Description copied from interface: `VectorStorageIntegral2Type`
    Set the `x` component.
    Specified by:
      `setX` in interface `VectorStorageIntegral2Type`
    Parameters:
      `x` - The X component

  - ### setY

    public void setY​(long y)
    Description copied from interface: `VectorStorageIntegral2Type`
    Set the `Y` component.
    Specified by:
      `setY` in interface `VectorStorageIntegral2Type`
    Parameters:
      `y` - The Y component

  - ### setZ

    public void setZ​(long z)
    Description copied from interface: `VectorStorageIntegral3Type`
    Set the `z` component.
    Specified by:
      `setZ` in interface `VectorStorageIntegral3Type`
    Parameters:
      `z` - The Z component

  - ### componentBytes

    protected final int componentBytes()

  - ### byteBuffer

    public final java.nio.ByteBuffer byteBuffer()
    Specified by:
      `byteBuffer` in interface `TensorByteBufferedType`
    Returns:
      The byte buffer that backs the tensor

  - ### byteOffset

    public final long byteOffset()
    Specified by:
      `byteOffset` in interface `TensorByteBufferedType`
    Returns:
      The byte offset of the current tensor

  - ### offset

    public final int offset()
    Specified by:
      `offset` in interface `TensorByteBufferedType`
    Returns:
      A constant offset added to `TensorByteBufferedType.byteOffset()`.

  - ### sizeBytes

    public final int sizeBytes()
    Specified by:
      `sizeBytes` in interface `TensorByteBufferedType`
    Returns:
      The size of a single tensor in bytes

  - ### byteOffsetForIndex

    protected final int byteOffsetForIndex​(int component_index)